//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <windowsx.h>
#include <shlobj.h>
#include "mvimgchk1.h"
#include "mvimgchk2.h"
#include "mvimgchk3.h"
#include "OleDragDrop.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFrmSpimg *FrmSpimg;
//---------------------------------------------------------------------------
TStringList *li,*li_di;
AnsiString TargetPath,fi_ini,fi_img;int drg;
int orgw,orgh;
//---- Replace
bool strReplace(AnsiString &st,AnsiString txt,AnsiString txt2){
 int a;bool re=false;
 while((a=AnsiPos(txt,st))!=0){st.Delete(a,txt.Length());st.Insert(txt2,a);re=true;}
 return re;
}
//---- split
void __fastcall TFrmSpimg::Split(AnsiString txt,char c){
 char *p,*q,gbuf[256],buf[128];
 StrPCopy(gbuf,txt);
 li_split->Clear();
 p=gbuf;q=buf;
 while(*p){
  if(*p==c){*q=0;li_split->Add(buf);q=buf;}
  else{*(q++)=*p;}++p;}
 *q=0;li_split->Add(buf);}

//---
bool chkExt(AnsiString fi,AnsiString ext){
// ShowMessage(IntToStr(fi.AnsiPos(ext))+":"+IntToStr(fi.Length()-ext.Length()));
 if(fi.LowerCase().AnsiPos(ext.LowerCase())==fi.Length()-ext.Length()+1){return true;}
 return false;}

//--------------------------------------------------------------
// Constructor
//--------------------------------------------------------------
__fastcall TFrmSpimg::TFrmSpimg(TComponent* Owner)
	: TForm(Owner)
{ OleInitialize(NULL);
 fi_ini=ExtractFilePath(Application->ExeName)+"spimgchk.ini";
 li_ini=new TStringList();
 li_split=new TStringList();
 LoadIni();
 Susie.set_spipath(INI("SusiePath").c_str());
 mnStrech->Checked=(INI("Stretch")==1)?true:false;
 li=new TStringList();
 li_di=new TStringList();drg=0;

 if(ParamCount()>0){
  AnsiString fi=ParamStr(1);
  if(FileExists(fi))fi=ExtractFileDir(fi);
  RefreshList(fi);
  Tag=1;}
}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::LoadIni(void){
 if(FileExists(fi_ini)){
  try{
  li_ini->LoadFromFile(fi_ini);

  Width=StrToInt(INI("Width"));
  Height=StrToInt(INI("Height"));
  Left=StrToInt(INI("Left"));
  Top=StrToInt(INI("Top"));
  }catch(...){Application->MessageBox("iniװ","װ",MB_OK|MB_ICONERROR);}}
 else{// Default INI
  INI("DefaultDir")="c:\\";
  INI("SusiePath")=ExtractFilePath(Application->ExeName);
  INI("FileMask")="jpg,gif,png,bmp";
  INI("Stretch")=1;}}

void __fastcall TFrmSpimg::SaveIni(void){
 INI("Width")=IntToStr(Width);
 INI("Height")=IntToStr(Height);
 INI("Left")=IntToStr(Left);
 INI("Top")=IntToStr(Top);
 INI("Stretch")=(mnStrech->Checked)?1:0;
 li_ini->Sort();
 li_ini->SaveToFile(fi_ini);}

//------- listFile
bool __fastcall TFrmSpimg::chkTargetExt(AnsiString st){
 bool rs=false;int i;
 for(i=0;i<li_split->Count;i++){
  if(chkExt(st,"."+li_split->Strings[i]))rs=true;}
 return rs;
}

void __fastcall TFrmSpimg::ListFiles(AnsiString dirName){
int RC;
TSearchRec SearchRec;
AnsiString ss;
RC=FindFirst(dirName+"*.*",faAnyFile,SearchRec);
 while(RC==0){
  if(SearchRec.Name!=".."&&SearchRec.Name!="."){
   ss=dirName+SearchRec.Name;
   if((SearchRec.Attr&faDirectory)==0&&chkTargetExt(ss))li->Add(ss);
   if((SearchRec.Attr&faDirectory)>0){li_di->Add(ss);ListFiles(ss+"\\");}}
   RC=FindNext(SearchRec);}
//  finally
 FindClose(SearchRec);}

//---------------------------------
void __fastcall TFrmSpimg::RefreshList(AnsiString dir){
int i,j;
ListBox1->Visible=false;
li->Clear();ListBox1->Clear();li_di->Clear();
li_di->Add(dir);
TargetPath=dir+"\\";
Caption=TargetPath;
Split(INI("FileMask"),',');
ListFiles(TargetPath);
li->Sort();
li_di->Sort();
TStringList *li_buf=new TStringList();
for(j=li_di->Count-1;j>=0;--j){
 li_buf->Clear();
 AnsiString di=li_di->Strings[j];
 for(i=0;i<li->Count;i++){
  AnsiString st=li->Strings[i];
  if(st.AnsiPos(di)){
/* int a=st.Length();while(a>1&&st[a]!='\\')--a;--a;while(a>1&&st[a]!='\\')--a;st.Delete(1,a);*/
   strReplace(st,TargetPath,"");
   li_buf->Add(st);
   li->Delete(i);--i;}}
 ListBox1->Items->Text=li_buf->Text+ListBox1->Items->Text;}
 ListBox1->Visible=true;
}

//------------------------------------
void __fastcall TFrmSpimg::fixImageSize(void){
 if(!orgh&&!orgw)return;
 if(mnStrech->Checked==false||(orgh<=Panel1->Width&&orgw<=Panel1->Height)){
  Image1->Width=orgw;
  Image1->Height=orgh;return;}
 if(Panel1->Width*orgh/orgw<=Panel1->Height){
  Image1->Width=Panel1->Width;
  Image1->Height=Panel1->Width*orgh/orgw;}
 else{
  Image1->Height=Panel1->Height;
  Image1->Width=Panel1->Height*orgw/orgh;}
Image1->Refresh();
 }

void __fastcall TFrmSpimg::ListBox1Click(TObject *Sender)
{int a;
 if((a=ListBox1->ItemIndex)!=-1){
  AnsiString f=TargetPath+ListBox1->Items->Strings[a];
  if(chkExt(f,".bmp")){
   Image1->Picture->LoadFromFile(f);}
  else{
   if(Susie.set_file(f.c_str())){
    if(Susie.load()){
     Image1->Width=Susie.bmp->Width;
     Image1->Height=Susie.bmp->Height;
     Image1->Picture->Bitmap=Susie.bmp;}}}
  orgw=Image1->Width;orgh=Image1->Height;fixImageSize();
  StatusBar1->Panels->Items[0]->Text=IntToStr(orgw)+"x"+IntToStr(orgh);
  }
}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::Targetdir1Click(TObject *Sender)
{
 FrmSpImg2->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::Quit1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::FormClose(TObject *Sender, TCloseAction &Action)
{
 SaveIni();OleUninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::Setting1Click(TObject *Sender)
{
 FrmSpimg3->EdtDefaultDir->Text=INI("DefaultDir");
 FrmSpimg3->EdtSusiePath->Text=INI("SusiePath");
 FrmSpimg3->EdtFileMask->Text=INI("FileMask");
 if(FrmSpimg3->ShowModal()==mrOk){
  INI("DefaultDir")=FrmSpimg3->EdtDefaultDir->Text;
  INI("SusiePath")=FrmSpimg3->EdtSusiePath->Text;
  INI("FileMask")=FrmSpimg3->EdtFileMask->Text;}
}
//---------------------------------------------------------------------------
/* hbvt@C̍쐬 */
void __fastcall TFrmSpimg::DragStart(void){
 UINT cf=CF_HDROP;
 OLE_IDropSource_Start(Handle,WM_USER+100,0,&cf,1,DROPEFFECT_COPY|DROPEFFECT_MOVE|DROPEFFECT_LINK|DROPEFFECT_SCROLL);
}
/*  if(Shift.Contains(ssLeft)){++a;if(!dr&&a>10){//dr=true;
   li_drop->Clear();
   for(int i=0;i<FileListBox1->Items->Count;i++){
    if(FileListBox1->Selected[i])li_drop->Add(FileListBox1->Directory+"\\"+FileListBox1->Items->Strings[i]);}
   DragStart();}}*/

void __fastcall TFrmSpimg::GetData(TMessage Msg){
 HANDLE hMem = NULL;
 int num =1;
 char** dropfilename=(char**)malloc(1*sizeof(char*));
 if(!dropfilename)return;
// int index=ListView_GetNextItem(hwnd,-1,LVNI_SELECTED);
 char sztemp[_MAX_PATH];
 int i;
 for(i=0;i<num;i++){
  StrPCopy(sztemp,fi_img);
  dropfilename[i]=strdup(sztemp);
  if(!dropfilename[i])break;}
 num=i;
 if(num > 0){
   hMem=CreateDropFileMem(dropfilename,num);
   for(int i=0; i<num; i++)free(dropfilename[i]);
	}
	free(dropfilename);
 *(HANDLE*)Msg.LParam=hMem;
// lParam	return hMem;
}

void __fastcall TFrmSpimg::ListBox1MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{TPoint p;
 if(ListBox1->SelCount==0)return;

 if(Shift.Contains(ssLeft)||Shift.Contains(ssRight)){
  if(++drg==8){
   p.x=X;p.y=Y;
 //if(DragDetectPlus((int)((TWinControl*)Sender)->Handle,p)){
/*   li->Clear();
   for(i=0;i<ListBox1->Items->Count;i++){
    if(ListBox1->Selected[i])li->Add(TargetPath+ListBox1->Items->Strings[i]);}*/
   fi_img=TargetPath+ListBox1->Items->Strings[ListBox1->ItemIndex];
   Caption=fi_img;
   DragStart();//}
 }}else{drg=0;}
}
//---------------------------------------------------------------------------

void __fastcall TFrmSpimg::Panel1Resize(TObject *Sender)
{fixImageSize();}
//---------------------------------------------------------------------------
void __fastcall TFrmSpimg::mnStrechClick(TObject *Sender)
{
 mnStrech->Checked=!mnStrech->Checked;
 fixImageSize();
}
//---------------------------------------------------------------------------
