
//---------------------------------------------------------------------------
//
//      SUSIE vOC C++ Builder ŊȒPɎgp邽߂̃NXwb_
//
//                     class  TSpiload;
//
//			           Programed by CAT.Y
//
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef spi_loadH
#define spi_loadH

#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\graphics.hpp>

//---------------------------------------------------------------------------


// ============================================================================
//			SUSIE plug-in 擾邽߂̍\
// ============================================================================
struct PictureInfo
{
	long 	left, top;    	// WJʒu
    long 	width;       	// 摜̕
    long 	height;      	//       
    WORD 	x_density;   	// f̐x
    WORD 	y_density;   	// f̐x
    short 	color; 			// Pfbit
    HLOCAL 	info;    		// 摜̃eLXgwb_
};


// ============================================================================
// ============================================================================
//
//			SUSIE plug-in vV[WǗe[u
//
// ============================================================================
// ============================================================================
struct	TSpi_plugin
{
	int		err;
// ***** nh *****
	HANDLE			handle;

// ***** Xg|C^ *****
	TSpi_plugin		*next;

// ***** WJ\ȃt@C`ׂ *****
	int _export pascal (*IsSupported)(LPSTR filename, DWORD dw);

// ***** 摜t@CɊւ𓾂@*****
	int _export pascal (*GetPictureInfo)(LPSTR buf, long len, unsigned int flag
     									,struct PictureInfo *lpInfo);
// ***** 摜WJ *****
	int _export pascal (*GetPicture)(LPSTR buf, long len, unsigned int flag
              							,HANDLE *pHBInfo, HANDLE *pHBm
              							,FARPROC lpPrgressCallback, long lData);

// ***** vr[EJ^O\p摜kWJ[eB ******
	int _export pascal (*GetPreview)(LPSTR buf, long len, unsigned int flag
    									,HANDLE *pHBInfo, HANDLE *pHBm
                                        ,FARPROC lpPrgressCallback, long lData);


// ***** A[JCûׂẴt@C̏擾 *****
	int	_export pascal (*GetArchiveInfo)(LPSTR buf, long len
											,unsigned int flag, HLOCAL *lphInf);

// ***** A[JCũt@C擾 *****
	int	_export pascal (*GetFile)(LPSTR src, long len, LPSTR dest, unsigned int flag
                                            ,FARPROC prgressCallback, long lData);

// Constructor
	TSpi_plugin()
    {
		handle = NULL;
        next = NULL;
    };

// Destructor
	~TSpi_plugin()
    {
    	if (handle != NULL) {
        	FreeLibrary(handle);					// Cu
        }
    };

// ********** DLL Procedure address set *********
	bool	load_library(const char	*lib)
    {
    	bool	ret = false;

		handle = LoadLibrary(lib);					// Win32 API

    	if (handle != NULL) {
    		// === Win32 API ŃAhX擾 ===
			(void *)IsSupported    = GetProcAddress(handle, "IsSupported");
			(void *)GetPictureInfo = GetProcAddress(handle, "GetPictureInfo");
			(void *)GetPicture     = GetProcAddress(handle, "GetPicture");
			(void *)GetPreview     = GetProcAddress(handle, "GetPreview");
			(void *)GetArchiveInfo = GetProcAddress(handle, "GetArchiveInfo");
			(void *)GetFile        = GetProcAddress(handle, "GetFile");
            // === ȈՃG[`FbN ===
			ret = (IsSupported != NULL) & (GetPicture != NULL);
            if (ret == false)
            	err = GetLastError();
        }
        return	ret;
    };

};


// ============================================================================
// ============================================================================
//
//			SUSIE plug-in 摜擾ǗNX
//
// ============================================================================
// ============================================================================
class	TSpiload	{
	protected:

    	bool	err_flag;				// G[\tO
    	char	*spi_path;				// SPI ݂pX
    	char	*filename;				// File name
        char	ext[32];				// gq

        TSpi_plugin	*spi;				// vOCXg
		TSpi_plugin	*now_spi;			// ŌɊm肵vOC

	public:
        Graphics::TBitmap	*bmp;		// Bitmap f[^
        int		color_depth;			// Color ̐[(rbg)
        int		err;					// Win32 G[ԍ 


    	TSpiload()								// Constructor
        {
        	err_flag = true;
        	spi_path = new(char[1]);
        	filename = new(char[1]);
            *spi_path = *filename = NULL;		// Terminate string
            bmp = NULL;
            spi = NULL;
        }

       	~TSpiload()								// Destructor
        {
        	delete spi_path;
        	delete filename;

            if (bmp != NULL) delete bmp;
            if (spi != NULL) delete spi;
        }

        void	set_spipath(const char *path);	// SPI ̃pXݒ
        bool	set_file(const char *src);		// file name set & load
        bool	check(void);					// t@C̃`FbN
        bool	load(void);						// t@C̃[h
        void	clean(void);					// p\ްp
};

#endif
